from pandas import read_csv
from datetime import datetime
from numpy import zeros, mean
from matplotlib import pyplot as plt

def aggregate_cpu_week(path):
    cpu = zeros((7,24))
    count = zeros((7,24))
    data = read_csv(path).to_numpy()
    for i in range(len(data)):
        datum = datetime.fromisoformat(data[i,0])
        day   = datum.weekday()
        hour  = datum.hour
        for j in range(1,data.shape[1]):
            #convert string to float
            data[i,j] = float(data[i,j].strip('%'))
        cpu[day,hour] += mean(data[i][1:])
        count[day,hour] += 1
    cpu = cpu/count
    cpu = cpu.flatten()
    cpu.tofile('../cpu_week_curve.txt',sep=";")
    return cpu

path = '../'+input('Please enter the name of your csv file: ')
cpu = aggregate_cpu_week(path)
print('The week curve has been written succesfully to file: cpu_week_curve.txt \nCopy and paste it into the data sheet.')

if input('Would you like to visualize the curve? Confirm with [y]: ')=='y':
    plt.plot(cpu)
    plt.xlabel('168 hours of the week')
    plt.ylabel('cpu utilisation in %')
    days = ['monday','tuesday','wednesday','thursday','friday','saturday','sunday']
    i=0
    for day in days:
        plt.vlines(24*i, 0,100,'b','dashed')
        plt.text(24*i,80,day,rotation=90)
        i+=1
    plt.savefig('../cpu_week_curve.png')
    print('The plot has been saved to cpu_week_curve.png. Thank you!')